import { DataTypes, Model, Sequelize } from 'sequelize';
import { useContextKey } from '@kevisual/use-config/context';
export class Org extends Model {
  declare id: string;
  declare username: string;
  declare description: string;
  declare users: { role: string; uid: string }[];
}

export const OrgInit = (newSequelize?: any) => {
  const sequelize = useContextKey<Sequelize>('sequelize');
  Org.init(
    {
      id: {
        type: DataTypes.UUID,
        primaryKey: true,
        defaultValue: DataTypes.UUIDV4,
      },
      username: {
        type: DataTypes.STRING,
        allowNull: false,
        unique: true,
      },
      description: {
        type: DataTypes.STRING,
        allowNull: true,
      },
      users: {
        type: DataTypes.JSONB,
        allowNull: true,
        defaultValue: [],
      },
    },
    {
      sequelize: newSequelize || sequelize,
      modelName: 'cf_org',
      paranoid: true,
    },
  );

  Org.sync({ alter: true, logging: false }).catch((e) => {
    console.error('Org sync', e);
  });
  return Org;
};
useContextKey('OrgModel', () => Org);
